package at.jku.students;

import at.jku.ssw.Queue;
import at.jku.ssw.Iterator;

public class ArrayQueue extends Queue {
  
  private static final int MAX_SIZE = 100;
  private Object[] queue = new Object[MAX_SIZE];
  private int head = 0, tail = 0, count = 0;
  
  public void put(Object value) {
    if (count == queue.length) {
      throw new IllegalStateException();
    }
    queue[tail] = value;
    tail = (tail + 1) % queue.length;
    count++;
  }

  public Object get() {
    if (count == 0) {
      return null;
    }
    Object result = queue[head];
    head = (head + 1) % queue.length;
    count--;
    return result;
  }
  
  public int size() {
    return count;
  }
  
  public Iterator iterator() {
    Object array[] = new Object[count];
    int arrayIndex = 0;
    int queueIndex = head;
    while (queueIndex != tail) {
      array[arrayIndex] = queue[queueIndex];
      arrayIndex++;
      queueIndex = (queueIndex + 1) % queue.length;
    }
    return new ArrayQueueIterator(array);
  }
}